export declare const dialectIdentifier = "https://json-schema.org/draft/2020-12/schema";
declare type CoreKeywords = {
    $anchor?: string;
    $comment?: string;
    $defs?: {
        [key: string]: JsonSchema;
    };
    $dynamicAnchor?: string;
    $dynamicRef?: string;
    $id?: string;
    $ref?: string;
    $schema?: typeof dialectIdentifier;
    $vocabulary?: {
        [uri: string]: boolean;
    };
};
declare type LogicSubschemasKeywords = {
    allOf?: Array<JsonSchema>;
    anyOf?: Array<JsonSchema>;
    not?: JsonSchema;
    oneOf?: Array<JsonSchema>;
};
declare type ConditionalSubschemasKeywords = {
    dependentSchemas?: {
        [key: string]: JsonSchema;
    };
    else?: JsonSchema;
    if?: JsonSchema;
    then?: JsonSchema;
};
declare type MetaDataAnnotationKeywords = {
    default?: any;
    deprecated?: boolean;
    description?: string;
    examples?: Array<any>;
    readOnly?: boolean;
    title?: string;
    writeOnly?: boolean;
};
declare type FormatKeywords = {
    format?: string;
};
declare type JsonSchemaType = 'null' | 'boolean' | 'string' | 'integer' | 'number' | 'array' | 'object';
declare type CommonValidationKeywords = {
    const?: any;
    enum?: Array<any>;
    type?: JsonSchemaType | Array<JsonSchemaType>;
};
declare type StringValidationKeywords = {
    maxLength?: number;
    minLength?: number;
    pattern?: string;
};
declare type NumericValidationKeywords = {
    exclusiveMaximum?: number;
    exclusiveMinimum?: number;
    maximum?: number;
    minimum?: number;
    multipleOf?: number;
};
declare type ArrayValidationKeywords = {
    contains?: JsonSchema;
    items?: JsonSchema;
    maxContains?: number;
    maxItems?: number;
    minContains?: number;
    minItems?: number;
    prefixItems?: Array<JsonSchema>;
    uniqueItems?: boolean;
};
declare type ObjectValidationKeywords = {
    dependentRequired?: Record<string, Array<string>>;
    maxProperties?: number;
    minProperties?: number;
    required?: string[];
};
declare type ObjectSubschemaKeywords = {
    additionalProperties?: JsonSchema;
    patternProperties?: {
        [propertyNameRegex: string]: JsonSchema;
    };
    properties?: {
        [propertyName: string]: JsonSchema;
    };
    propertyNames?: JsonSchema;
};
declare type UnevaluatedLocationsKeywords = {
    unevaluatedItems?: JsonSchema;
    unevaluatedProperties?: JsonSchema;
};
export declare type JsonSchemaObject = CoreKeywords & LogicSubschemasKeywords & ConditionalSubschemasKeywords & CommonValidationKeywords & MetaDataAnnotationKeywords & FormatKeywords & StringValidationKeywords & NumericValidationKeywords & ArrayValidationKeywords & ObjectValidationKeywords & UnevaluatedLocationsKeywords & ObjectSubschemaKeywords;
export declare type JsonSchemaBoolean = boolean;
export declare type JsonSchema = JsonSchemaBoolean | JsonSchemaObject;
export {};
//# sourceMappingURL=2020-12.d.ts.map